/* -*-java-*- tsin.java */

import java.io.*;

public class tsin
{
    // shorthands to avoid the need for fully-qualified names, sigh...
    private static float ABS(float x)			{ return (elefunt.ABS(x)); }
    private static float ALOG(float x)			{ return (elefunt.ALOG(x)); }
    private static float AMAX1(float x,float y)		{ return (elefunt.AMAX1(x,y)); }
    private static float COS(float x)			{ return (elefunt.COS(x)); }
    private static float IPOW(float x,int n)		{ return (elefunt.IPOW(x,n)); }
    private static float POW(float x,float y)		{ return (elefunt.POW(x,y)); }
    private static float RAN()				{ return (elefunt.RAN()); }
    private static float SIN(float x)			{ return (elefunt.SIN(x)); }
    private static float SQRT(float x)			{ return (elefunt.SQRT(x)); }
    private static float TO_FP_T(long n)		{ return (elefunt.TO_FP_T(n)); }

    public static void tsin()
    {
	/*#     PROGRAM to test sin/cos
	#
	#     data required
	#
	#        none
	#
	#     subprograms required from this package
	#
	#        machar - an environmental inquiry program providing
	#                 information on the floating-point arithmetic
	#                 system.  note that the call to machar can
	#                 be deleted provided the following five
	#                 parameters are assigned the values indicated
	#
	#                 ibeta  - the radix of the floating-point system
	#                 it     - the number of base-ibeta digits in the
	#                          significand of a floating-point number
	#                 minexp - the largest in magnitude negative
	#                          integer such that  float(ibeta)**minexp
	#                          is a positive floating-point number
	#                 eps    - the smallest positive floating-point
	#                          number such that 1.0+eps != 1.0
	#                 epsneg - the smallest positive floating-point
	#                          number such that 1.0-epsneg != 1.0
	#
	#        ran(k) - a function subprogram returning random real
	#                 numbers uniformly distributed over (0,1)
	#
	#
	#     standard fortran subprograms required
	#
	#         alog, amax1, cos, float, sin, sqrt
	#
	#
	#     latest revision - december 6, 1979
	#
	#     author - w. j. cody
	#              argonne national laboratory
	#
	#*/
	final float ait = TO_FP_T(machar.it);
	final float alxmax = ALOG(machar.xmax);
	final float beta = TO_FP_T(machar.ibeta);
	final float albeta = ALOG(beta);
	final float ONE = elefunt.ONE;
	final float TWO = elefunt.TWO;
	final float ZERO = elefunt.ZERO;

	int i,
	    j,
	    k1,
	    k2,
	    k3,
	    n;

	float
	    a,
	    b,
	    betap,
	    c,
	    del,
	    expon,
	    r6,
	    r7,
	    three,
	    w,
	    x,
	    xl,
	    xn,
	    x1,
	    y,
	    z,
	    zz;

	/*******************************************************************/

	elefunt.banner("tsin");

	ran.ranset(initseed.initseed());

	three = 3.0e0F;
	a = ZERO;
	b = 1.570796327e0F;
	c = b;
	n = (int)maxtest.maxtest();
	xn = TO_FP_T(n);
	z = ZERO;

	/* random argument accuracy tests */

	for (j = 1; j <= 3; ++j)
	{
	    k1 = 0;
	    k3 = 0;
	    x1 = ZERO;
	    r6 = ZERO;
	    r7 = ZERO;
	    del = (b - a) / xn;
	    xl = a;

	    for (i = 1; i <= n; ++i)
	    {
		x = del * RAN() + xl;
		y = x / three;
		y += x;
		y -= x;
		x = three * y;
		if (j == 3)
		{
		    z = COS(x);
		    zz = COS(y);
		    w = ONE;
		    if (z != ZERO)
			w = (z + zz * (three - 4.0e0F * zz * zz)) / z;
		}
		else
		{
		    z = SIN(x);
		    zz = SIN(y);
		    w = ONE;
		    if (z != ZERO)
			w = (z - zz * (three - 4.0e0F * zz * zz)) / z;
		}
		if (w > ZERO)
		    k1 = k1 + 1;
		if (w < ZERO)
		    k3 = k3 + 1;
		w = ABS(w);
		if (w > r6)
		{
		    r6 = w;
		    x1 = x;
		}
		r7 = r7 + w * w;
		xl = xl + del;
	    }

	    k2 = n - k3 - k1;
	    r7 = SQRT(r7 / xn);
	    if (j == 3)
	    {
		System.out.print("1TEST OF COS(X) VS 4*COS(X/3)**3-3*COS(X/3)\n\n");
		System.out.print("" + fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
		System.out.print("      (" + fmt.E(a,15,4) + "," + fmt.E(b,15,4) + ")\n\n\n");
		System.out.print(" COS(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
		System.out.print("            AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
		System.out.print("       WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n");
	    }
	    else
	    {
		System.out.print("1TEST OF SIN(X) VS 3*SIN(X/3)-4*SIN(X/3)**3\n\n");
		System.out.print("" + fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
		System.out.print("      (" + fmt.E(a,15,4) + "," + fmt.E(b,15,4) + ")\n\n\n");
		System.out.print(" SIN(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
		System.out.print("            AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
		System.out.print("       WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n");
	    }
	    System.out.print(" THERE ARE" + fmt.I(machar.it,4) + " BASE" +
			     fmt.I(machar.ibeta,4) + " SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER\n\n");
	    w = -999.0e0F;
	    if (r6 != ZERO)
		w = ALOG(ABS(r6)) / albeta;
	    System.out.print(" THE MAXIMUM RELATIVE ERROR OF" + fmt.E(r6,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    System.out.print("    OCCURRED FOR X =" + fmt.E(x1,17,6) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    w = -999.0e0F;
	    if (r7 != ZERO)
		w = ALOG(ABS(r7)) / albeta;
	    System.out.print(" THE ROOT MEAN SQUARE RELATIVE ERROR WAS" + fmt.E(r7,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    a = 18.84955592e0F;
	    if (j == 2)
		a = b + c;
	    b = a + c;
	}

	/* special tests */

	System.out.print("1SPECIAL TESTS\n\n");
	c = ONE / IPOW(beta, (machar.it / 2));
	z = (SIN(a + c) - SIN(a - c)) / (c + c);
	System.out.print(" IF " + fmt.E(z,13,6) + " IS NOT ALMOST 1.0E0F,    SIN HAS THE WRONG PERIOD.\n\n");

	System.out.print(" THE IDENTITY   SIN(-X) = -SIN(X)   WILL BE TESTED.\n");
	System.out.print("     X        F(X) + F(-X)\n");

	for (i = 1; i <= 5; ++i)
	{
	    x = RAN() * a;
	    z = SIN(x) + SIN(-x);
	    System.out.print("" + fmt.E(x,15,7) + "" + fmt.E(z,15,7) + "\n\n");
	}

	System.out.print(" THE IDENTITY SIN(X) = X , X SMALL, WILL BE TESTED.\n");
	System.out.print("    X         X - F(X)\n\n");
	betap = IPOW(beta, machar.it);
	x = RAN() / betap;

	for (i = 1; i <= 5; ++i)
	{
	    z = x - SIN(x);
	    System.out.print("" + fmt.E(x,15,7) + "" + fmt.E(z,15,7) + "\n\n");
	    x = x / beta;
	}

	System.out.print(" THE IDENTITY   COS(-X) = COS(X)   WILL BE TESTED.\n");
	System.out.print("        X         F(X) - F(-X)\n");

	for (i = 1; i <= 5; ++i)
	{
	    x = RAN() * a;
	    z = COS(x) - COS(-x);
	    System.out.print("" + fmt.E(x,15,7) + "" + fmt.E(z,15,7) + "\n\n");
	}

	System.out.print(" TEST OF UNDERFLOW FOR VERY SMALL ARGUMENT.\n\n");
	expon = TO_FP_T(machar.minexp) *0.75e0F;
	x = POW(beta, expon);
	y = SIN(x);
	System.out.print("\n       SIN(" + fmt.E(x,13,6) + ") = " + fmt.E(y,13,6) + "\n");
	System.out.print(" THE FOLLOWING THREE LINES ILLUSTRATE THE LOSS IN SIGNIFICANCE\n");
	System.out.print(" FOR LARGE ARGUMENTS.  THE ARGUMENTS ARE CONSECUTIVE.\n");
	z = SQRT(betap);
	x = z * (ONE - machar.epsneg);
	y = SIN(x);
	System.out.print("\n       SIN(" + fmt.E(x,13,6) + ") =" + fmt.E(y,13,6) + "\n");
	y = SIN(z);
	System.out.print("\n       SIN(" + fmt.E(z,13,6) + ") =" + fmt.E(y,13,6) + "\n");
	x = z * (ONE + machar.eps);
	y = SIN(x);
	System.out.print("\n       SIN(" + fmt.E(x,13,6) + ") =" + fmt.E(y,13,6) + "\n");

	/* test of error returns */

	System.out.print("1TEST OF ERROR RETURNS\n\n\n");

	x = betap;
	System.out.print(" SIN WILL BE CALLED WITH THE ARGUMENT" + fmt.E(x,15,4) + "\n");
	System.out.print(" THIS SHOULD TRIGGER AN ERROR MESSAGE\n\n\n");
	try
	{
	    y = SIN(x);
	}
	catch (ArithmeticException e)
	{
	    y = elefunt.errout("ERROR: SIN(" + x + ") raised " + e);
	}
	System.out.print(" SIN RETURNED THE VALUE" + fmt.E(y,15,4) + "\n\n\n\n");

	System.out.print(" THIS CONCLUDES THE TESTS\n");
    }

    public static void main(String[] args)
    {
	tsin();
    }
}
