/* -*-java-*- tsqrt.java */

import java.io.*;

public class tsqrt
{
    // shorthands to avoid the need for fully-qualified names, sigh...
    private static float ABS(float x)			{ return (elefunt.ABS(x)); }
    private static float ALOG(float x)			{ return (elefunt.ALOG(x)); }
    private static float AMAX1(float x,float y)		{ return (elefunt.AMAX1(x,y)); }
    private static float RAN()				{ return (elefunt.RAN()); }
    private static float RANDL(float x)			{ return (elefunt.RANDL(x)); }
    private static float SQRT(float x)			{ return (elefunt.SQRT(x)); }
    private static float TO_FP_T(long n)		{ return (elefunt.TO_FP_T(n)); }

    public static void tsqrt()
    {
	/*    PROGRAM TO TEST SQRT
	#
	#     DATA REQUIRED
	#
	#        NONE
	#
	#     SUBPROGRAMS REQUIRED FROM THIS PACKAGE
	#
	#        MACHAR - AN ENVIRONMENTAL INQUIRY PROGRAM PROVIDING
	#                 INFORMATION ON THE FLOATING-POINT ARITHMETIC
	#                 SYSTEM.  NOTE THAT THE CALL TO MACHAR CAN
	#                 BE DELETED PROVIDED THE FOLLOWING SIX
	#                 PARAMETERS ARE ASSIGNED THE VALUES INDICATED
	#
	#                 IBETA  - THE RADIX OF THE FLOATING-POINT SYSTEM
	#                 IT     - THE NUMBER OF BASE-IBETA DIGITS IN THE
	#                          SIGNIFICAND OF A FLOATING-POINT NUMBER
	#                 EPS    - THE SMALLEST POSITIVE FLOATING-POINT
	#                          NUMBER SUCH THAT 1.0+EPS .NE. 1.0
	#                 EPSNEG - THE SMALLEST POSITIVE FLOATING-POINT
	#                          NUMBER SUCH THAT 1.0-EPSNEG .NE. 1.0
	#                 XMIN   - THE SMALLEST NON-VANISHING FLOATING-POINT
	#                          POWER OF THE RADIX
	#                 XMAX   - THE LARGEST FINITE FLOATING-POINT NO.
	#
	#      RANDL(X) - A FUNCTION SUBPROGRAM RETURNING LOGARITHMICALLY
	#                 DISTRIBUTED RANDOM REAL NUMBERS.  IN PARTICULAR,
	#                        A * RANDL(ALOG(B/A))
	#                 IS LOGARITHMICALLY DISTRIBUTED OVER (A,B)
	#
	#        RAN(K) - A FUNCTION SUBPROGRAM RETURNING RANDOM REAL
	#                 NUMBERS UNIFORMLY DISTRIBUTED OVER (0,1)
	#
	#
	#     STANDARD FORTRAN SUBPROGRAMS REQUIRED
	#
	#         ABS, ALOG, AMAX1, FLOAT, SQRT
	#
	#
	#     LATEST REVISION - AUGUST 2, 1979
	#
	#     AUTHOR - W. J. CODY
	#              ARGONNE NATIONAL LABORATORY
	#
	*****************************************************************************/

	final float ait = TO_FP_T(machar.it);
	final float beta = TO_FP_T(machar.ibeta);
	final float albeta = ALOG(beta);
	final float ONE = elefunt.ONE;
	final float ZERO = elefunt.ZERO;

	int i,
	    j,
	    k1,
	    k2,
	    k3,
	    n;

	float
	    a,
	    b,
	    c,
	    r6,
	    r7,
	    sqbeta,
	    w,
	    x,
	    xn,
	    x1,
	    y,
	    z;

	/*******************************************************************/

	elefunt.banner("tsqrt");

	ran.ranset(initseed.initseed());

	sqbeta = SQRT(beta);
	a = ONE / sqbeta;
	b = ONE;
	n = (int)maxtest.maxtest();
	xn = TO_FP_T(n);
	c = ZERO;
	z = ZERO;

	/* random argument accuracy tests */

	for (j = 1; j <= 2; ++j)
	{
	    c = ALOG(b / a);
	    k1 = 0;
	    k3 = 0;
	    x1 = ZERO;
	    r6 = ZERO;
	    r7 = ZERO;

	    for (i = 1; i <= n; ++i)
	    {
		x = a * RANDL(c);
		y = x * x;
		z = SQRT(y);
		w = (z - x) / x;
		if (w > ZERO)
		    k1 = k1 + 1;
		if (w < ZERO)
		    k3 = k3 + 1;
		w = ABS(w);
		if (w > r6)
		{
		    r6 = w;
		    x1 = x;
		}
		r7 = r7 + w * w;
	    }

	    k2 = n - k1 - k3;
	    r7 = SQRT(r7 / xn);
	    System.out.print("1TEST OF SQRT(X*X) - X\n\n\n");
	    System.out.print(fmt.I(n,7) + " RANDOM ARGUMENTS WERE TESTED FROM THE INTERVAL\n");
	    System.out.print("       (" + fmt.E(a,15,4) + "," + fmt.E(b,15,4) + ")\n\n\n");
	    System.out.print(" SQRT(X) WAS LARGER" + fmt.I(k1,6) + " TIMES,\n");
	    System.out.print("             AGREED" + fmt.I(k2,6) + " TIMES, AND\n");
	    System.out.print("        WAS SMALLER" + fmt.I(k3,6) + " TIMES.\n\n\n");
	    System.out.print(" THERE ARE" + fmt.I(machar.it,4) + " BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IN A FLOATING-POINT NUMBER\n\n\n");
	    w = -999.0e0F;
	    if (r6 != ZERO)
		w = ALOG(ABS(r6)) / albeta;
	    System.out.print(" THE MAXIMUM RELATIVE ERROR OF" + fmt.E(r6,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    System.out.print("    OCCURRED FOR X =" + fmt.E(x1,17,6) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    w = -999.0e0F;
	    if (r7 != ZERO)
		w = ALOG(ABS(r7)) / albeta;
	    System.out.print(" THE ROOT MEAN SQUARE RELATIVE ERROR WAS" + fmt.E(r7,15,4) +
			     " = " + fmt.I(machar.ibeta,4) + " **" + fmt.F(w,7,2) + "\n");
	    w = AMAX1(ait + w, ZERO);
	    System.out.print(" THE ESTIMATED LOSS OF BASE" + fmt.I(machar.ibeta,4) +
			     " SIGNIFICANT DIGITS IS" + fmt.F(w,7,2) + "\n\n\n");
	    a = ONE;
	    b = sqbeta;
	}

	/* special tests */

	System.out.print("1TEST OF SPECIAL ARGUMENTS\n\n\n");
	x = machar.xmin;
	y = SQRT(x);
	System.out.print(" SQRT(XMIN) = SQRT(" + fmt.E(x,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");
	x = ONE - machar.epsneg;
	y = SQRT(x);
	System.out.print(" SQRT(1-EPSNEG) = SQRT(1-" + fmt.E(machar.epsneg,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");
	x = ONE;
	y = SQRT(x);
	System.out.print(" SQRT(1.0) = SQRT(" + fmt.E(x,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");
	x = ONE + machar.eps;
	y = SQRT(x);
	System.out.print(" SQRT(1+EPS) = SQRT(1+" + fmt.E(machar.eps,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");
	x = machar.xmax;
	y = SQRT(x);
	System.out.print(" SQRT(XMAX) = SQRT(" + fmt.E(x,15,7) + ") = " + fmt.E(y,15,7) + "\n\n\n");

	/* test of error returns */

	System.out.print("1TEST OF ERROR RETURNS\n\n\n");

	x = ZERO;
	System.out.print(" SQRT WILL BE CALLED WITH THE ARGUMENT " + fmt.E(x,15,4) + "\n");
	System.out.print(" THIS SHOULD NOT TRIGGER AN ERROR MESSAGE\n\n\n");
	try
	{
	    y = SQRT(x);
	}
	catch (ArithmeticException e)
	{
	    y = elefunt.errout("ERROR: SQRT(" + x + ") raised " + e);
	}
	System.out.print(" SQRT RETURNED THE VALUE " + fmt.E(y,15,4) + "\n\n\n");

	x = -ONE;
	System.out.print("\nSQRT WILL BE CALLED WITH THE ARGUMENT " + fmt.E(x,15,4) + "\n");
	System.out.print(" THIS SHOULD TRIGGER AN ERROR MESSAGE\n\n\n");
	try
	{
	    y = SQRT(x);
	}
	catch (ArithmeticException e)
	{
	    y = elefunt.errout("ERROR: SQRT(" + x + ") raised " + e);
	}
	System.out.print(" SQRT RETURNED THE VALUE " + fmt.E(y,15,4) + "\n\n\n\n");

	System.out.print(" THIS CONCLUDES THE TESTS\n");

    }

    public static void main(String[] args)
    {
	tsqrt();
    }
}
